#include <stdio.h>
#include <stdlib.h>
#include "boolean.h"
#include "readField.h"
#include "answer.h"

Answer* createAnswerArray(int answerCount)
{
	int i;
	Answer *answerArray = (Answer*)malloc(sizeof(Answer) * answerCount);
	for (i = 0; i < answerCount; i++)
	{
		answerArray[i].code = '\0';
		answerArray[i].text[0] = '\0';
		answerArray[i].points = 0;
	}
	return answerArray;
}

void destroyAnswerArray(Answer *answerArray)
{
	free(answerArray);
}

Boolean readAnswerFromTxt(FILE *file, Answer *answer)
{
	Boolean ok;
	char sepChar;

	ok = fscanf(file, "%c;%f;", &answer->code, &answer->points) == 2;
	sepChar = readField(answer->text, '\n', file);
	ok = ok && (sepChar == '\n' || sepChar == EOF);
	return ok;
}

Answer* readAnswerArrayFromTxt(FILE *file, int answerCount)
{
	Boolean ok = true;
	int i;
	Answer *answerArray = createAnswerArray(answerCount);

	for (i = 0; i < answerCount && ok; i++)
	{
		ok = readAnswerFromTxt(file, answerArray + i);
	}
	if (!ok)
	{
		destroyAnswerArray(answerArray);
		answerArray = NULL;
	}
	return answerArray;
}

void renderAnswer(Answer *answer)
{
	printf("%c - %s", answer->code, answer->text);
}