#include <stdio.h>
#include "boolean.h"
#include "answer.h"

#ifndef QUIZ
#define QUIZ

#define QUESTION_DIM 512

typedef char QuestionText[QUESTION_DIM];

typedef struct QuizStruct
{
	QuestionText text;
	int answerCount;
	Answer *answers;
} Quiz;

typedef struct QuizListElementStruct
{
	Quiz *quiz;
	struct QuizListElementStruct *next;
} QuizListElement;

typedef QuizListElement *QuizList;

#endif

Quiz* createQuiz();
void destroyQuiz(Quiz* quiz);

//Crea una struttura QuizList in memoria dinamica
QuizList createQuizList(Quiz* quiz);
void destroyQuizList(QuizList q);

void printAll(QuizList quiz);

//Lettura singolo quiz da file
Quiz* readQuizFromTxt(FILE *file);

//Lettura tutti quiz da file
QuizList readQuizListFromTxt(FILE *file);

//Rendering singolo quiz
void renderQuiz(Quiz *quiz);

//Lettura risposta singolo quiz
Answer* readAnswerFromUser(Quiz *quiz);

//Valutazione esame completo
float doAssessment(QuizList quiz);